/*
Пример использования
Ресурса диска
1. Создавать диск
2. Редактировать диск
3. Удалять диск
*/

#Раскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    dynamix = {
      source  = "basistech.ru/tf/dynamix"
      version = "<VERSION>"
    }
  }
}
*/

provider "dynamix" {
  authenticator = "decs3o"
  #controller_url = <DYNAMIX_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DYNAMIX_OAUTH2_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "dynamix_disk" "disk" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  #используется при создании
  account_id = 88366

  #название диска
  #обязательный параметр
  #тип - строка
  #используется при создании и обновлении
  disk_name = "super-disk-re"

  #максимальный размер диска, в ГБ
  #обязательный параметр
  #тип - целое число
  #используется при создании и обновлении
  size_max = 20

  #sep id
  #опциональный параметр
  #тип - целое число
  #по умолчанию - 0
  #используется при создании
  #sep_id = 1

  #название pool
  #опциональный параметр
  #тип - строка
  #используется при создании
  #pool = "pool_name"

  #описание диска
  #опциональный параметр
  #тип - строка
  #используется при создании и обновлении
  #desc = "description"

  #флаг поделиться диском
  #опциональный параметр
  #тип - булев
  #по умолчанию - false
  #используется при создании и обновлении
  #shareable = true

  #настройки лимитов операций записи/чтения с диска
  #опциональный параметр
  #тип - блок
  #тип вложенных полей - целое число
  #используется при создании и обновлении
  #iotune = {
    #read_bytes_sec      = 0
    #read_bytes_sec_max  = 0
    #read_iops_sec       = 0
    #read_iops_sec_max   = 0
    #size_iops_sec       = 0
    #total_bytes_sec     = 0
    #total_bytes_sec_max = 0
    #total_iops_sec      = 3000
    #total_iops_sec_max  = 0
    #write_bytes_sec     = 0
    #write_bytes_sec_max = 0
    #write_iops_sec      = 0
    #write_iops_sec_max  = 0
  #}

  #флаг для удаления диска, без возможности восстановления
  #опциональный параметр
  #тип - булев
  #по умолчанию - true
  #используется при удалении
  #permanently = true

  #флаг отсоединения диска от машины перед удалением
  #опциональный параметр
  #тип - булев
  #по умолчанию - true
  #используется при удалении
  #detach = true
}

output "test" {
  value = dynamix_disk.disk
}
